<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="800">
      <v-card>
        <v-form ref="taskForm" @submit.prevent="sendForm()">
          <v-toolbar v-if="!$store.getters['isMobile']" dark extended extension-height="4" color="blue">
            <span class="headline black--text">
              <v-icon color="black" size="30px" >assignment</v-icon>
              &nbsp;&nbsp;
              <span v-if="task && task.id === -1">Add a task</span>
              <span v-else>Edit a task</span>
            </span>
            <v-spacer></v-spacer>
            <progress-bar
              :loading="sending"
              color="deep-purple accent-4"
              slot="extension"
            />
          </v-toolbar>
          <v-container fluid grid-list-md>
              <v-layout fluid wrap>
                <v-flex xs12 sm8>
                  <v-text-field :rules="rules.required" v-model="obj.title" label="Task title*" required></v-text-field>
                </v-flex>
                <v-flex hidden-xs-only md2 offset-md2>
                  <v-checkbox
                    color="green"
                    label="Task done"
                    v-model="obj.checked"
                  ></v-checkbox>
                </v-flex>
                <v-flex xs12>
                  <v-textarea
                    :rules="rules.descriptionSize"
                    name="input-7-1"
                    no-resize
                    label="Description"
                    v-model="obj.description"
                    clearable
                    clear-icon="cancel"
                  ></v-textarea>
                </v-flex>
                <v-flex xs12 hidden-sm-and-up>
                  <v-checkbox
                    color="green"
                    label="Task done"
                    v-model="obj.checked"
                  ></v-checkbox>
                </v-flex>
              </v-layout>
            <small>* Required field</small>
          </v-container>
          <v-card-actions>
            <v-btn color="red darken-1" flat @click="$emit('cancel')">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn type="submit" color="green darken-1" flat >
              <span v-if="task && task.id === -1">Add</span>
              <span v-else>Save</span>
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
import progressBar from '@/components/NavBar/ProgressBar'

import TaskService from '@/services/TaskService'

export default {
  components: {
    'progress-bar': progressBar
  },
  props: {
    dialog: {
      type: Boolean,
      required: true
    },
    list: {
      required: true
    },
    task: {
      required: false,
      default: null
    }
  },
  data: () => ({
    taskService: new TaskService(),
    obj: {
      title: '',
      description: '',
      checked: false
    },
    sending: false
  }),
  watch: {
    task: function (val) {
      this.$refs.taskForm.resetValidation()
      if (val) {
        this.obj = this.task
      } else {
        this.obj = {
          title: '',
          description: '',
          checked: false
        }
      }
    }
  },
  computed: {
    rules: function () {
      return {
        required: [
          val => (val || '').length > 0 || 'Required field'
        ],
        descriptionSize: [
          val => (val || '').length < 1000 || 'Maximum 1000 cheracters'
        ]
      }
    }
  },
  methods: {
    sendForm: function () {
      if (this.$refs.taskForm.validate()) {
        this.sending = true
        this.obj.id = this.task.id
        this.obj.listId = this.list.id
        if (this.obj.id === -1) {
          this.taskService.addTask(this.obj).then((response) => {
            this.obj = {
              title: '',
              description: '',
              checked: false
            }
            this.$emit('refreshList')
            this.sending = false
          }, (error) => {
            this.errorService.getServeurNotif(error.status, error.bodyText)
            this.$store.dispatch('alert/error', { content: 'Impossible to add the task. Try again later.' })
            this.sending = false
          })
        } else {
          this.taskService.editTask(this.obj).then((response) => {
            this.obj = {
              title: '',
              description: '',
              checked: false
            }
            this.$emit('refreshList')
            this.sending = false
          }, (error) => {
            this.errorService.getServeurNotif(error.status, error.bodyText)
            this.$store.dispatch('alert/error', { content: 'Impossible to edit task. Please try again later.' })
            this.sending = false
          })
        }
      }
    }
  }
}
</script>
